【C#入門】try-catchの使い方総まとめ(finally/throw)

こんにちは!エンジニアの中沢です。

C#には例外処理をするための「try-catch-finally」があります。「try-catch-finally」を使った例外処理が行われていないと、実行時エラーが発生したときにそこでプログラムが終了してしまうので注意が必要です。

また、「throw」を使えば例外を作成したり、例外を再スローすることができるので、ぜひ活用してください。

この記事では、

  • try-catch-finallyとは
  • try-catchの使い方
  • finallyで必ず実行する処理を記述する方法
  • throwとは
  • throwで例外を発生させる方法
  • throwで例外を再スローする方法

などの基本的な内容から、応用的な使い方に関しても解説していきます。今回はこれらの方法を覚えるために、例外処理をするさまざまな使い方をわかりやすく解説します!

try-catch-finallyとは

try-catch-finallyとは、例外が発生する可能性がある処理に使うものです。try-catch-finallyを使うことで、例外が発生しない場合の処理と、例外が発生したときの処理を分けることができます。

さらに、finallyを使って例外の有無に関わらず、最後に必ず実行される処理を記述することができます。try-catch-finallyは次のように記述します。

try {
    例外が発生する可能性のある処理
} catch (例外の型 引数) {
    例外が発生した場合の処理(例外が発生しなければ行われない処理)
} finally {
    例外の有無に関わらず、最後に必ず実行される処理
}

try-catchの使い方

ここでは、try-catchの使い方を解説します。try-catchは、tryブロックの中に例外が発生する可能性のある処理を記述し、catchブロックの中に例外が発生した後の処理を記述します。

try-catchの使い方を次のプログラムで確認してみましょう。

using System;

namespace Sample
{
    class Sample
    {
        static int DivSample(int num1, int num2)
        {
            try
            {
                int result = num1 / num2;

                return result;
            }
            catch (ArithmeticException e)
            {
                Console.WriteLine("例外が発生しました。");
                Console.WriteLine(e);

                return 0;
            }

        }

        static void Main()
        {
            int result;
            result = DivSample(5, 0);

            Console.WriteLine("戻り値 = " + result);

            Console.ReadKey();
        }
    }
}

実行結果:

例外が発生しました。
System.DivideByZeroException: 0 で除算しようとしました。
戻り値 = 0

このプログラムでは、DivSampleメソッドで割り算を行い、その結果を呼び出し元のmainメソッドに返しています。

0で割り算を行っているので、DivideByZeroExceptionの例外をスローして、catchブロックの中の処理が行われていることがプログラムの実行結果から確認できます。その後、呼び出し元のmainメソッドの処理が行われています。

finallyで必ず実行する処理を記述する方法

ここでは、finallyの使い方を解説します。finallyブロックの中の処理は、例外の有無に関わらず、最後に必ず実行されます。そのため、finallyはファイルを開いた後に確実にCloseメソッドで閉じたいときなどに使用されます。

次のテキストファイルを読み込み表示するプログラムで、finallyの使い方を確認してみましょう。

using System;
using System.IO;
using System.Text;

namespace Sample
{
    class Sample
    {
        static void Main()
        {
            StreamReader sr = null;

            try
            {
                sr = new StreamReader(@"E:samurai.txt", Encoding.GetEncoding("Shift_JIS"));

                string str = sr.ReadToEnd();

                Console.WriteLine(str);
            }
            catch (IOException e)
            {
                Console.WriteLine("例外が発生しました");
                Console.WriteLine(e);
            }
            finally
            {
                if (sr != null)
                {
                    sr.Close();
                    Console.WriteLine("ファイルを閉じました");
                }
            }
            Console.ReadKey();
        }
    }
}

実行結果:

侍エンジニア塾
ファイルを閉じました

このプログラムでは、ファイルを開いて内容を表示した後にfinallyブロックの中でファイルを閉じています。try-catch-finallyの詳しい使い方はこちらの記事で解説しているので、ぜひ確認してください。

【C#入門】try-catch-finallyで例外処理をする方法
更新日 : 2019年5月14日

throwとは

throwを使えば、例外を作成して任意のタイミングでスローすることができます。また、キャッチした例外を呼び出し元のメソッドに再スローすることもできます。

throwで例外を発生させる方法

ここでは、throwで例外を発生させる方法を解説します。throwを使えば、例外の種類を指定して、任意のタイミングで例外を発生させることができます。

次のプログラムで確認してみましょう。

using System;

namespace Sample
{
    class Sample
    {
        static int DivSample(int num1, int num2)
        {
            if (num2 != 0)
            {
                int result = num1 / num2;
                return result;
            }
            else
            {
                throw new DivideByZeroException();
            }
        }

        static void Main()
        {
            try
            {
                int result = DivSample(5, 0);
                Console.WriteLine(result);
            }
            catch (Exception e)
            {
                Console.WriteLine("例外をキャッチしました");
                Console.WriteLine(e);
            }

            Console.ReadKey();
        }
    }
}

実行結果:

例外をキャッチしました
System.DivideByZeroException: 0 で除算しようとしました。

このようにして、例外を発生させることができました。

throwで例外を再スローする方法

ここでは、throwで例外を再スローする方法を解説します。catchブロックの中でthrowを使うと、呼び出し元のメソッドへ例外を再スローすることができます。

次のプログラムで確認してみましょう。

using System;

namespace Sample
{
    class Sample
    {
        static int DivSample(int num1, int num2)
        {
            return num1 / num2;
        }

        static int ThrowSample(int num1, int num2)
        {
            try
            {
                return DivSample(num1, num2);
            }
            catch (Exception e)
            {
                throw;
            }
        }

        static void Main()
        {
            try
            {
                DivSample(5, 0);
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }

            Console.ReadKey();
        }
    }
}

実行結果:

System.DivideByZeroException: 0 で除算しようとしました。

このようにして、例外を再スローすることができました。throwの詳しい使い方はこちらの記事で解説しているので、ぜひ確認してください。

【C#入門】throwで例外の作成や再スローする方法(try-catch)
更新日 : 2019年4月25日

まとめ

いかがでしたか?

今回はtry-catch-finallyとthrowで例外処理をする方法を解説しました。finallyを使えば確実に処理を行うことができるので、ぜひ活用してくださいね。

もし、例外処理をする方法を忘れてしまったらこの記事を確認してください!

LINEで送る
Pocket

「プログラミング、右も左もわからない…」という方にオススメ

当プログラミングスクール「侍エンジニア塾」では、これまで6000人以上のエンジニアを輩出してきました。

その経験を通してプログラミング学習に成功する人は、「目的目標が明確でそれに合わせた学習プランがあること」「常に相談できる人がそばにいること」「自己解決能力が身につくこと」この3つが根付いている傾向を発見しました。

侍エンジニア塾は上記3つの成功ポイントを満たすようなサービス設計に磨きをかけております。

cta_under_bnr

「自分のスタイルや目的に合わせて学習を進めたいな」とお考えの方は、ぜひチェックしてみてください。

書いた人

中沢 丈

中沢 丈

フリーランスエンジニア。
システム開発からコンテンツ作成まで幅広く対応します。

連絡先はこちらです。
[email protected]